/*
	By IQ_132 - http://neosource.1emu.net
	Feel free to use this code in any way you wish as long as:

	1. You make public any source changes you make (if you publish a binary)
	2. You give do not claim this as your own work
*/

#include <stdio.h>
#include <string.h>

// version 1.0

// Set region and output file extension
unsigned char set_region(unsigned char clang, char *ext)
{
	char ans[4], extn[4][4] = {  "bg5", "gb", "eng", "jp" };
	
	printf ("\nWhat region would you like to set this file to?\n");
	if (clang != 0x09) printf ("Big5 (Chinese), ");
	if (clang != 0x23) printf ("GB (Chinese), ");
	if (clang != 0x12) printf ("English, ");
	if (clang != 0x07) printf ("Japanese, ");
	printf ("or No?\n");
	gets (ans);

	// Since there are two Chinese settings...
	if (ans[0] == 'c' || ans[0] == 'C')
	{
		printf ("\nChinese is not a valid answer.  Please choose either Big5, GB, or No.\n");
		gets (ans);
	}

	// Actually copy the extension & then return the XOR value
	switch (ans[0] & 0x0f)
	{
		case 0x02:	// bg5
			memcpy (ext, extn[0], 4);
		return 0x09;

		case 0x05:	// eng
			memcpy (ext, extn[2], 4);
		return 0x12;

		case 0x07:	// gb
			memcpy (ext, extn[1], 4);
		return 0x23;

		case 0x0a:	// jp
			memcpy (ext, extn[3], 4);
		return 0x07;
	}

	return 0;
}

int main()
{
	FILE *fz;
	int i, j, nLen;
	unsigned char *src;
	char name[64], ans[4];

	printf ("Please type the name of the file you wish to work with.\n");
	gets (name);

	fz = fopen (name, "rb");
	if (fz == NULL)
	{
		printf ("%s not found.\n", name);
		return 1;
	}

	// Get file length
	fseek (fz, 0, SEEK_END);
	nLen = ftell (fz);
	rewind (fz);

	src = (unsigned char *)malloc( nLen );

	fread (src, 1, nLen, fz);
	fclose (fz);

	// Figure out how the file is initially XORed (0xA0-0xA7 is "DSBooter")
	for (i = 0, j = 0; i < 0x100; i++)
	{
		if ((src[0xA0] ^ i) == 'D' && (src[0xA1] ^ i) == 'S')
		{
			j = i;
			break;
		}
	}

	if (j == 0x00)
	{
		printf ("\nThis file doesn't seem to be protected.  Continue? (Yes / No)\n");
		gets (ans);

		if (ans[0] == 'n' || ans[0] == 'n')
		{
			free (src);
			return 1;
		}
	}			

	// Find the location of the period in the file name
	i = strlen(name);
	while (name[i-1] != '.') i--;

	// Load i with the XOR value and copy the proper extension to the file name
	i = set_region(j, name + i);

	if (i == 0)
	{
		printf ("\nThe file will not be modified. Quitting.\n");
		free (src);
		return 1;
	}

	// Simple XOR on the first 512 bytes
	for (j ^= i, i = 0; i < 0x200; i++)
	{
		src[i] ^= j;
	}

	fz = fopen(name, "wb");
	fwrite (src, 1, nLen, fz);
	fclose (fz);

	free (src);

	printf ("\n%s has been written. Press any key to quit.\n", name);
	getch();
}
